; 1-Wire Definitions Pin and Macro
#define W1_Page		movlb	0x0	; BSR  Bank-0 for 1-W  Task
#define	Timer0_Present	Yes	;      


; 10/09/2020      
;      40,48,50    
; #define ClkMHz	48	;    -   - 
;  -          
#if ClkMHz == 48	;      48/16=3
;   Step_36   1-Ware:
	#define W1_D480u	d'1440'		; 1   1-W -  500 
	#define W1_D70u		d'210'		; 2   1-W
	#define W1_D410u	d'1230'		; 1   1-W
;   Step_37  0  1-Ware:
	#define W1_D60u		d'180'		; 1   0  1-W
	#define W1_D10u		d'30'		; 2   0  1-W
;   Step_38  1  1-Ware:
	#define W1_D6u		d'18'		; 1   1  1-W
	#define W1_D64u		d'192'		; 2   1  1-W
;   Step_39    1-Ware:
	#define W2_D6u		d'18'		; 1    1-W
	#define W1_D9u		d'27'		; 2    1-W
	#define W1_D55u		d'165'		; 3    1-W
#endif		

#if ClkMHz == 40	;      40/16=2.5
;   Step_36   1-Ware:
	#define W1_D480u	d'1200'		; 1   1-W -  500 
	#define W1_D70u		d'175'		; 2   1-W
	#define W1_D410u	d'1025'		; 1   1-W
;   Step_37  0  1-Ware:
	#define W1_D60u		d'150'		; 1   0  1-W
	#define W1_D10u		d'25'		; 2   0  1-W
;   Step_38  1  1-Ware:
	#define W1_D6u		d'15'		; 1   1  1-W
	#define W1_D64u		d'160'		; 2   1  1-W
;   Step_39    1-Ware:
	#define W2_D6u		d'15'		; 1    1-W
	#define W1_D9u		d'23'		; 2    1-W
	#define W1_D55u		d'138'		; 3    1-W
#endif		

#if ClkMHz == 50	;      50/16=3.125
;   Step_36   1-Ware:
	#define W1_D480u	d'1563'		; 1   1-W -  500 
	#define W1_D70u		d'219'		; 2   1-W
	#define W1_D410u	d'1281'		; 1   1-W
;   Step_37  0  1-Ware:
	#define W1_D60u		d'187'		; 1   0  1-W
	#define W1_D10u		d'31'		; 2   0  1-W
;   Step_38  1  1-Ware:
	#define W1_D6u		d'19'		; 1   1  1-W
	#define W1_D64u		d'200'		; 2   1  1-W
;   Step_39    1-Ware:
	#define W2_D6u		d'19'		; 1    1-W
	#define W1_D9u		d'28'		; 2    1-W
	#define W1_D55u		d'172'		; 3    1-W
#endif		

#if ClkMHz == 8	;      8/16=1/2
;   1-  8 
;   Step_36   1-Ware:
	#define W1_D480u	d'250'		; 1   1-W -  500 
	#define W1_D70u		d'35'		; 2   1-W
	#define W1_D410u	d'205'		; 1   1-W
;   Step_37  0  1-Ware:
	#define W1_D60u		d'30'		; 1   0  1-W
	#define W1_D10u		d'5'		; 2   0  1-W
;   Step_38  1  1-Ware:
	#define W1_D6u		d'3'		; 1   1  1-W
	#define W1_D64u		d'32'		; 2   1  1-W
;   Step_39    1-Ware:
	#define W2_D6u		d'3'		; 1    1-W
	#define W1_D9u		d'4'		; 2    1-W
	#define W1_D55u		d'27'		; 3    1-W
#endif		


#ifndef	W1_D55u
	messg "1-Ware Clock value ClkMHz unrecognized, using default 48 MHz" 
#endif		

#ifdef	__DEBUG
	#define Debug_1W	 	1 	;   5, , 1= 
#else
	#define Debug_1W	 	0 	;   5, , 1= 
#endif

#define MaxW1Pointer	d'24';d'45'	;   1-Wire
#define MaxW1Sensors	d'8'	;   1-Wire
#define Write_W1_Sensor	d'15'	;     1-Wire


;     1-Wire:
;  - 1 ROM  - 1  Functional 

#define DS1820_SEARCHROM 		0xF0	; ROM  
#define DS1820_SKIP_ROM			0xCC	; ROM  
#define DS1820_READROM 			0x33	; ROM  
#define DS1820_MATCHROM 		0x55	; ROM  
;#define DS1820_ALARMSEARCH 	0xEC	; ROM  

;#define DS1820_WRITE_SCRATCHPAD 0x4E; Functional 
#define DS1820_READ_SCRATCHPAD	0xBE ; Functional 
;#define DS1820_COPY_SCRATCHPAD 0x48 ; Functional 
;#define DS1820_READ_EEPROM 	0xB8 ; Functional 
;#define DS1820_READ_PWRSUPPLY 	0xB4 ; Functional 
#define DS1820_CONVERT_T		0x44 ; Functional 
;#define DS1820_FAMILY_CODE_DS18B20      0x28
;#define DS1820_FAMILY_CODE_DS18S20      0x10

