;******************************************************************************
;    Filename: LCD_SyncEeprom.Asm                                                   *
;    Date:                                                                    *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;                                                                             *
;    Files required:         P18F4431.INC, Pic18_M.INC,LCD_Text.asm           *
;                                                                             *
;******************************************************************************
	#include Define.h	;     
;*******************************
;    -   
;*******************************
 #ifdef	EPROM_Present

;#define ParametrStor	d'7'	;    
;#define FsrLoadParam	lfsr	0,Par_T1	; -0  
;          
;   .     
;  ,   -     

; ,  / ,   .
;    ,     
;  -    ,  ,   
;   .

;  -    ,  ,   ,
;      .
;          .
;       -  .
;     1       ,
;  ""     1    2  
;   "  "  =0 (  ),
;  "Bad Block"  .

;  2  16/01/2019:
;   " ",        
;   .         
;   .
;    -       N    .
;            
;    ,   .
;   -      .
;    -    ,        .
; /   -           . 
;   -       -       .
; 



	global	EPROM_Read,EPROM_Sync;,EPROM_Table;,ParametrStor

EPROM_Sync	code
	Extern	InitAll, MotorFault
 #ifdef	RestoreMainLoop
;      NOP
;       - 
	movlw	0x17	;    
 	extern	Restore_ML ; #endif ; #ifdef	RestoreMainLoop
 call	Restore_ML	; 0x17        
 #endif ; #ifdef	RestoreMainLoop

;	goto	InitAll	;       - 



;EPROM_Table
; #include Proj_Dir\EPROM\EPROM_RegsAdr.inc	;      
;EPROM_Sync
;;    
; (EPROM_Sync-EPROM_Table)/2;   
; EPROM_DatE-EPROM_DatB	;    
; ParametrCmn	d'15';      
; ParamBlockNum d'16';    
; error "Access RAM exeeds 96 byte"
; messg "Access RAM lenght " \x EndOfAccess

; *******  	
;	movlw (EPROM_Sync-EPROM_Table)/2
;	movlw (EPROM_DatE-EPROM_DatB-ParametrCmn)/ParamBlockNum

; #if ((EPROM_Sync-EPROM_Table)/2) != (EPROM_DatE-EPROM_DatB-ParametrCmn)/ParamBlockNum ; 
;	#if ((EPROM_Sync-EPROM_Table)/2) > (EPROM_DatE-EPROM_DatB-ParametrCmn)/ParamBlockNum ; 
;	;error "     "
;	 messg "Size RAM Block Greater than lenght of EPROM" 
; 	#else
;	 messg "Size RAM Block Less than lenght of EPROM" 
; 	#endif
;	;error "     "
;	;messg "Size RAM Block not eq lenght EPROM" 
; #else
;	 messg "Size RAM Block Exactly Equal lenght of EPROM" 
; #endif

; #if ((EPROM_Sync-EPROM_Table)/2) != (ParametrCmn+ParamBlockLen) ;   
;  error "Size defined RAM Block NOT equal summ of ParametrCmn + ParamBlockLen" 
; #endif
; #if (EPROM_DatE-EPROM_DatB) != (ParametrCmn+ParamBlockLen*ParamBlockNum) ;    
;  messg "Size defined EPROM Block NOT equal summ of ParametrCmn + ParamBlockLen*ParamBlockNum" 
; #endif
;
EPROM_Sync
 
	EPROM_Page ; BSR for EPROM Task
 	BTFSC EECON1, WR ; Wait for write to complete
 return	;    -  

	BCF EECON1, WREN,ACCESS	; Disable writes - all time
	BCF PIR2, EEIF,ACCESS 	; Clear interrupt flag

	btfsc	LCD_Flg1,1,ACCESS	;   ?
		bra	Ee_Done1			;  
	btfss PCPWM_Flag1,5,ACCESS;5=  /    (    )
		bra	Ee_StoppedMotor		;   
	clrf CountSyn,BANKED;           
;   
;	incf	CountSyn,F,BANKED		;    -   
;      +2 =   
		Extern	EPROM_Table
	movlf	 low(EPROM_Table),TblPtrBuf+0,BANKED;TBLPTRL,ACCESS;   
	movlf	high(EPROM_Table),TblPtrBuf+1,BANKED;TBLPTRH,ACCESS;    
;	clrf	TBLPTRU,ACCESS		;<64 kB     
	bsf		LCD_Flg1,1,ACCESS	;    
		bra	Ee_Done1			;    

Ee_StoppedMotor
;MotorNumberCompare;          
;       

 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         
	BCF EECON1, EEPGD,ACCESS; Point to DATA memory	
	clrf	EEADR,ACCESS	;  
	BSF EECON1,RD,ACCESS	; EEPROM Read =  EEDATA
	BSF EECON1, EEPGD,ACCESS; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    

	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15
	movff   WREG,PCPWM_MotorNum ;   

	cpfseq	EEDATA,ACCESS;      
		bra	MotorNumChange	;    -       
;    -    .

	clrf CountSyn,BANKED;           
;   
	incf	CountSyn,F,BANKED		;    -   
;     +2 =   
	movlf	 low(EPROM_Table+2),TblPtrBuf+0,BANKED;TBLPTRL,ACCESS;   
	movlf	high(EPROM_Table+2),TblPtrBuf+1,BANKED;TBLPTRH,ACCESS;    
;	clrf	TBLPTRU,ACCESS		;<64 kB     
	bsf		LCD_Flg1,1,ACCESS	;    
		bra	Ee_Done1			;  


Ee_Done1	;        

	BCF EECON1, CFGS,ACCESS		; Point to memory
	clrf	TBLPTRU,ACCESS		;<64 kB     
  movff_N	 TblPtrBuf,TBLPTRL,2;<64 kB;     

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
;SkipDummyBadBlock
	tblrd*+	;    
	movff	TABLAT,FSR0L	;   

	tblrd*+	;      
	movff	TABLAT,FSR0H	;   

  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;      
;     

;  -        
;	tstfsz	FSR0H,ACCESS	; "BAD Block" dummy address
;		bra Ee_Done2
;	tstfsz	FSR0L,ACCESS	;   
;		bra Ee_Done2
;;
;	bra SkipDummyBadBlock	;      -
; return	;   "-"     

	btfsc	LCD_Flg1,5,ACCESS	;     ?
		bra	Ee_Done2			;    

 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         

	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
	
	MOVFF CountSyn,EEADR ; Data Memory Address to read
;	MOVFF EE_AdrTemp,EEADR ; Data Memory Address to read
	BSF EECON1, RD,ACCESS		 ; EEPROM Read =  EEDATA

	movf	INDF0,W,ACCESS	;     

	cpfseq	EEDATA,ACCESS		;     
		rcall	Ee_Write		;    


	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    

	incf	CountSyn,F,BANKED		;   

;	movlw	(EPROM_Sync-EPROM_Table)/2;   
	movlw	ParametrCmn-1	;    

;	cpfslt	CountSyn,BANKED		;    
	cpfsgt	CountSyn,BANKED		;    
 return	; /   1       
 	bsf		LCD_Flg1,5,ACCESS	;     
 return	; /   1     
		;  ;   	
Ee_Done2	;      
	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15
;	movff   WREG,PCPWM_MotorNum ;   

	mullw	ParamBlockLen; d'13';    
	movf	PRODL,W,ACCESS	;   
;	decf	PRODL,W,ACCESS	;  -1 (  ) 
	addwf	CountSyn,W,BANKED	;    
	movwf	EEADR,ACCESS ;   EPROM

 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         

	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
	
;	MOVFF CountSyn,EEADR ; Data Memory Address to read
;	MOVFF EE_AdrTemp,EEADR ; Data Memory Address to read
	BSF EECON1, RD,ACCESS		 ; EEPROM Read =  EEDATA

	movf	INDF0,W,ACCESS	;     

	cpfseq	EEDATA,ACCESS		;     
		rcall	Ee_Write		;    


	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    

	incf	CountSyn,F,BANKED		;   
	movlw	ParametrCmn+ParamBlockLen-1	;    
;	cpfslt	CountSyn,BANKED		;    
	cpfsgt	CountSyn,BANKED		;    
 return	; /   1       
;EndSyncEprom
	bcf		LCD_Flg1,0,ACCESS	;  
	bcf		LCD_Flg1,1,ACCESS	;    
	bcf		LCD_Flg1,5,ACCESS	;     
 return

Ee_Write;    
	movwf	EEDATA,ACCESS		;          
	incf	EpromWriteCount,F,ACCESS	;
Ee_WriteFactory	; 05/11/2021      
	;BCF EECON1, EEPGD ; Point to DATA memory
	BSF EECON1, WREN,ACCESS; Enable writes
	BCF INTCON, GIE,ACCESS; Disable Interrupts
		MOVLW 0x55 ;
		MOVWF EECON2,ACCESS ; Write 55h
		MOVLW 0xAA ;
		MOVWF EECON2,ACCESS ; Write AAh
	BSF EECON1, WR,ACCESS ; Set WR bit to begin write
	BCF EECON1, WREN,ACCESS ; Disable writes - not affect for begin write
	BSF INTCON, GIE,ACCESS ; Enable Interrupts
 return

; 05/11/2021  " " 
;        ,   
	global FactoryCopy	;     - 
FactoryCopy				; ""      
;    10  (    )
; c:\Microchip\_Prg\RTOS_3F_4431\PCPWM_3F\DiagString.inc  ~23
;	EPROM_Page ; BSR for EPROM Task -   
	extern	MotorFault	;  
	call	MotorFault	;   
	bcf	PIE1,ADIE,ACCESS ;   
	bcf	PIE3,PTIE,ACCESS ;   PCPWM
	bcf	INTCON,TMR0IE,ACCESS;   TMR0
	bcf	PIE3,TMR5IE,ACCESS	;   MR5
	BCF INTCON, PEIE,ACCESS; Disable Interrupts Low/Periferial
	BCF INTCON, GIE,ACCESS; Disable Interrupts High/All

 	clrf EpromWriteCount,acs;     
	BCF EECON1, CFGS,ACCESS ; Point to memory	
		Extern	EPROM_FData,EPROM_FData_End	;   
	movlf	low(EPROM_FData),TBLPTRL,ACCESS;   
	movlf	high(EPROM_FData),TBLPTRH,ACCESS;    
	movlf	low(EPROM_FData_End),PRODL,ACCESS;    
	movlf	high(EPROM_FData_End),PRODH,ACCESS;   
	Sub16	PRODL,acs,TBLPTRL,acs;macro ArgB,A1B,ArgA,A1A ;   -  
	
	clrf	TBLPTRU,ACCESS		;<64 kB 
LoopCopyFactoryEprom		;
	clrwdt ;  4  - ,  4+ 
 	BTFSC EECON1, WR ; Wait for write to complete
	;	bra $-2		;    
		bra	LoopCopyFactoryEprom		;
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
	tblrd*+	;      
;	movf	TABLAT,W,acs	;     -     
	BCF EECON1, EEPGD,ACCESS ; Point to DATA memory
	MOVFF EpromWriteCount,EEADR ; Data Memory Address to write -    
	MOVFF TABLAT,EEDATA ; Eprom Data to write 
		rcall	Ee_WriteFactory ;    
	BCF INTCON, GIE,ACCESS; Disable Interrupts High/All
	incf	EpromWriteCount,F,ACCESS	;
	movf	PRODL,W,acs					;   .
	cpfsgt	EpromWriteCount,acs			; 
		bra	LoopCopyFactoryEprom		;

 #ifndef	__DEBUG
			reset;return	;    ? -    
 #else	
			return	; reset;    ? -    
 #endif ;#ifndef	__DEBUG


MotorNumChange	;    -       
;     -  ,  -  
	movlw	0xEE;    
 call	MotorFault	;       
	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15
;	movff   WREG,PCPWM_MotorNum ;   
 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         
	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
	clrf	EEADR,ACCESS	;  =   
 rcall	Ee_Write		;    
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    

 	BTFSC EECON1, WR ; Wait for write to complete
	bra $-2;      
;		reset


EPROM_Read	;          -  19/01/2019
	EPROM_Page ; BSR for EPROM Task
;   -     , 2  .
;            .

; 14/11/2021     16 -    (   )

	bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         
	BCF EECON1, EEPGD,ACCESS; Point to DATA memory	
	clrf	EEADR,ACCESS	;     
	incf	EEADR,ACCESS	;    
	BSF EECON1,RD,ACCESS	; EEPROM Read =  EEDATA
;	BSF EECON1, EEPGD,ACCESS; Point to PROGRAM memory -   
; bsf	INTCON,GIEL,ACCESS	;      
	movff	EEDATA,PCPWM_MotorNumDbg ;,F,BANKED;          
	movlw	0x55	; ParamBlockNum+1	;0x10;    
	cpfslt	EEDATA,acs		;      0xFF
		bra	FactoryCopy		;       

;       
	clrf	EEADR,ACCESS	;     
	clrf CountSyn,BANKED;      
	BCF EECON1, CFGS,ACCESS ; Point to memory	

;	movlf	low(EPROM_Table),TblPtrBuf,BANKED;TBLPTRL,ACCESS;   
;	movlf	high(EPROM_Table),TblPtrBuf+1,BANKED;TBLPTRH,ACCESS;    

	movlf	low(EPROM_Table),TBLPTRL,ACCESS;   
	movlf	high(EPROM_Table),TBLPTRH,ACCESS;    

	clrf	TBLPTRU,ACCESS		;<64 kB 
;  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;     
	
LoopReadEpromCmn
;  movff_N	 TblPtrBuf,TBLPTRL,2;<64 kB;     

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

	tblrd*+	;    
	movff	TABLAT,FSR0L	;   

	tblrd*+	;      
	movff	TABLAT,FSR0H	;   

;  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;      
;     

	BCF EECON1, EEPGD,ACCESS ; Point to DATA memory

	MOVFF CountSyn,EEADR ; Data Memory Address to read
	BSF EECON1, RD,ACCESS ; EEPROM Read
	nop	; EPROM DATA Valid
	
;	movff	EEDATA,INDF0	;      
	movf	EEDATA,W,ACCESS
	movwf	INDF0,ACCESS	;      

	incf	CountSyn,F,BANKED		;   
;	movlw	(EPROM_Sync-EPROM_Table)/2;ParametrStor	;   
	movlw	ParametrCmn-1	;    
;	cpfslt	CountSyn,BANKED		;    
	cpfsgt	CountSyn,BANKED		;    
; 		return 
;		bra		ReadIndivid	; 
		bra LoopReadEpromCmn

LoopReadEpromInd
	movff   PCPWM_MotorNum,WREG ;   
	andlw	0x0F	;   0-15
;	movff   WREG,PCPWM_MotorNum ;   

	mullw	ParamBlockLen; d'13';    
	movf	PRODL,W,ACCESS	;   
	addwf	CountSyn,W,BANKED	;    
	movwf	EEADR,ACCESS ;   EPROM

;  movff_N	 TblPtrBuf,TBLPTRL,2;<64 kB;     

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

	tblrd*+	;    
	movff	TABLAT,FSR0L	;   

	tblrd*+	;      
	movff	TABLAT,FSR0H	;   

;  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;      
;     

	BCF EECON1, EEPGD,ACCESS ; Point to DATA memory
;	MOVFF CountSyn,EEADR ; Data Memory Address to read
;	movwf	EEADR,ACCESS ;        
	BSF EECON1, RD,ACCESS ; EEPROM Read
	nop	; EPROM DATA Valid
	
;	movff	EEDATA,INDF0	;      
	movf	EEDATA,W,ACCESS
	movwf	INDF0,ACCESS	;      

	incf	CountSyn,F,BANKED		;   
;	movlw	(EPROM_Sync-EPROM_Table)/2;ParametrStor	;   
	movlw	ParametrCmn+ParamBlockLen-1	;    
;	cpfslt	CountSyn,BANKED		;    
	cpfsgt	CountSyn,BANKED		;    
		bra LoopReadEpromInd
			return 
	

;*******************************
;    -   
;*******************************
 #endif	;#ifdef	EPROM_Present
;End of program

		END
