;******************************************************************************
;    Filename: Interrupt.Asm                                                   *
;    Date:                                                                    *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
	#include Define.h	;     
	global	LowInt
	;Extern	InitAll,HighInt
;******************************************************************************
; 15/11/2021         ,
;       
;Reset vector
; This code will start executing when a reset occurs.
RST		code	0x0000 ;
RST	;  4    
 bsf	OSCCON,IRCF2,ACCESS	;    RC  4  
;      2  + BRA
	#ifdef	PCPWM_Present
 IRAM_Stop	; 2    Define_PCPWM_3F
 	#endif; #ifdef	PCPWM_Present
 bra	AfterIntVectors	;       
;  
;		goto	InitAll		;go to start of main code

HiInt	code	0x0008	;  8    
;    
	btfsc	INTCON,TMR0IF,ACCESS; 0 -    1-Wire  
		bra	IntTimer0
;  2    -    
	bcf	PIR3,PTIF,ACCESS	; PCPWM

 #ifdef	PCPWM_Present	;
;	btfsc	W_1_Flg,5,ACCESS;5=       -   
; bsf		W_1_Flg,0,ACCESS;  1-Wire  ,   ,   1-W,
 #endif ; #ifdef	PCPWM_Present	;

 retfie	FAST;

;  0x18  0x08  8  
;  c 5, 3  .
;    1      32   
;     
	bra	0x0	; 
	bra	0x0	; 
	bra	0x0	; 
	bra	0x0	; 
LowInt	code	0x0018	;  bra	AfterIntVectors	;      1024 

 #ifdef	DelayCuriosityTest	; 07/03/2020   
	bcf	PIR1,ADIF,ACCESS	; ADC Flag Clear  
 #endif ; #ifdef DelayCuriosityTest

;
	bra	IntAdc

;	global	AfterIntVectors	;  Bra  
	Extern	InitAll
AfterIntVectors
 	clrwdt ;  4  - ,  4+ 
	movlf	b'01110000',OSCCON,ACCESS	;   8  
 #ifdef	PCPWM_Present
 	ITRIP_Stop	;  ITRIP      PWM
 #endif ; #ifdef	PCPWM_Present
		goto	InitAll		;go to start of main code

IntTimer0:
	bcf		INTCON,TMR0IF,ACCESS;   0
;	bcf		T0CON,TMR0ON,ACCESS	;  
 #ifdef	Timer0_Present
 		#include Proj_Dir\1W\Int_1W.inc	;   .
 #endif ;#ifdef	Timer0_Present
		retfie FAST	;; 

 #ifdef Beeper_Present
Beeper_Sub
 #ifdef Beeper_Tone	;     
	tstfsz	Beep,ACCESS	 ; 
	Beeper_Toggle		 ;  
	tstfsz	Beep,ACCESS	 ; 
	decf	Beep,F,ACCESS; 
 #endif ;#ifdef Beeper_Tone
		return	;
 #endif ;#ifdef Beeper_Present

; Low priority interrupt vector and routine
; This code will start executing when a low priority interrupt occurs.
; This code can be removed if low priority interrupts are not used.
LowInt: ; - ,   
IntAdc: ;    ,     PCPWM

		movff	WREG,WREG_TEMP		;save working register
		movff	STATUS,STATUS_TEMP	;save STATUS register
		movff	BSR,BSR_TEMP		;save BSR register

;       
;		movff	FSR0L,FSR0L_Temp	;  
;		movff	FSR0H,FSR0H_Temp	;  
		movff	TBLPTRL,TBLPTRL_Temp	;
		movff	TBLPTRH,TBLPTRH_Temp	;
;		movff	TBLPTRU,TBLPTRU_Temp	;  
;		movff	EECON1,EECON1_Temp	;    
		movff	TABLAT,TABLAT_Temp		;			
		movff	PRODH,PRODH_Temp		;
		movff	PRODL,PRODL_Temp		;


AdcIntNest	;        
;  0,6    /    18 750 .
;  0,8    /    24 414 .
;  ~2     ""  12 - 12.5 .

 #ifndef	DelayCuriosityTest	; 07/03/2020   
	bcf	PIR1,ADIF,ACCESS	; ADC Flag Clear       
 #endif	; #ifndef	DelayCuriosityTest	


 #ifdef	ADC_Present

 #ifdef Beeper_Tone
	tstfsz	Beep,ACCESS	 ;   -  ?
		rcall	Beeper_Sub;   
 #endif ; #ifdef Beeper_Tone

 #ifndef __DEBUG_;*******  
	#include Proj_Dir\ADC\Int_ADC.inc	;       .
 #endif	;#ifndef __DEBUG_;

 #ifdef	RTK_ADC_Source
 	#include Proj_Dir\RTK\Int_RTK_Tmr.inc	;   -   
 #endif ; #ifdef	RTK_ADC_Source

 #ifdef	PCPWM_Present
PDC_Int_Begin
    #include Proj_Dir\PCPWM_3F\Int_PCPWM_24bcounter.inc ;    	

; 04/12/2022   16  ,    +1
; 10/12/2022    BRA   -   
	decfsz	PCPWM_AccelCounter+0,F,ACCESS;      /  
		bra		DoneAccelCounter		 ;
	dcfsnz	PCPWM_AccelCounter+1,F,ACCESS;      /
		bsf PCPWM_Flag,5,ACCESS	;;5=     9 375  ,   
DoneAccelCounter
;; 07/06/2020     -     
;       

;	btfsc	PIR3,PTIF,ACCESS	;  PCPWM  ?
;	btfss	PCPWM_Flag,6,ACCESS;6= RealStop PCPWM Module ;   ?
;		bra	PDC_Int_End
;	bcf		PIR3,PTIF,ACCESS	;   


	
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

	 #ifndef __DEBUG;*******  
		; Extern	PCPWM_Task
		;	call	PCPWM_Task ;  ,   .

 #ifdef  b9H8_12quart ;	; 13/06/2020     
  #ifndef	PCPWM_RES
	#define PCPWM_RES Yes ; 
  #endif ; #ifndef	PCPWM_RES
;  3    1/4   12  1/2  -   	
	#include Proj_Dir\PCPWM_3F\Int_PCPWM_3H_x431.inc ;    3    .	
 #endif; #ifdef  b9H8_12quart

 #ifdef  b12_12half	; 13/06/2020     
  #ifndef	PCPWM_RES
	#define PCPWM_RES Yes ; 
  #endif ; #ifndef	PCPWM_RES
 ;#ifdef	PCPWM_3H	; 07/03/2020  
 		#include Proj_Dir\PCPWM_3F\Int_PCPWM_3F_x431.inc ;     .	
 #endif; #ifdef  b12_12half	;
  #ifndef	PCPWM_RES
	error "Phase Resolution Not Defined"
  #endif ; #ifndef	PCPWM_RES

 	 #endif ; #ifndef __DEBUG_;*******  



PDC_Int_End



 #endif ; #ifdef	PCPWM_Present

 #endif ;  #ifdef	ADC_Present

 #ifdef	DelayCuriosityTest	; 07/03/2020   

; #ifdef	DelayCuriosityTest	; 07/03/2020   
	Extern	DelayCuriosity	;   
	call	DelayCuriosity	;	    
; #endif ; #ifdef	DelayCuriosityTest


	btfss	PIR1,ADIF,ACCESS; ADC
		bra	ExitLoInt
	bcf	PIR1,ADIF,ACCESS	; ADC Flag Clear
	#ifdef	PCPWM_Present
 		incf	PCPWM_Err,F,ACCESS	;   
	#endif ; #ifdef	PCPWM_Present
 #else ; #ifdef	DelayCuriosityTest	;
	btfsc	PIR1,ADIF,ACCESS; ADC	;     
 #endif ; #ifdef DelayCuriosityTest	;
	goto 	AdcIntNest	;          

;;		rcall	IntAdc

ExitLoInt ;          

; 15/11/2021          
; (    ) -       10    
;      .

;#ifdef	PCPWM_Present
;	btfss	PCPWM_Flag2,0,ACCESS;;0=     
;		rcall	PDC_TableLoad	;      
;	btfss	PCPWM_Flag2,1,ACCESS;0=       
;		rcall	Angle_TableLoad	;      
; #endif ; #ifdef	PCPWM_Present
; 
;      
;		movff	FSR0L_Temp,FSR0L	;variable used for context saving
;		movff	FSR0H_Temp,FSR0H	;variable used for context saving
		movff	TBLPTRL_Temp,TBLPTRL	;
		movff	TBLPTRH_Temp,TBLPTRH	;
;		movff	TBLPTRU_Temp,TBLPTRU	;
;		movff	EECON1_Temp,EECON1	;    
		movff	TABLAT_Temp,TABLAT		;			
		movff	PRODH_Temp,PRODH		;
		movff	PRODL_Temp,PRODL		;

		movff	BSR_TEMP,BSR		;restore BSR register
		movff	WREG_TEMP,WREG		;restore working register
		movff	STATUS_TEMP,STATUS	;restore STATUS register
			retfie
;	global	PDC_TableLoad
;PDC_TableLoad	;	   
; 	bsf PCPWM_Flag2,0,ACCESS;;0=     
; #include Proj_Dir\PCPWM_3F\PDC_TableLoad.inc;    
;	return
;
;Angle_TableLoad	;
;	bsf	PCPWM_Flag2,1,ACCESS;1=       
; #include Proj_Dir\PCPWM_3F\Angle_TableLoad.inc;     
;	return
;
;
; #ifdef	Timer1_Present
;	btfss	PIR1,TMR1IF,ACCESS	; 1-10    DC 
;		bra	NextInt1
;	btfsc	PIE1,TMR1IE,ACCESS		;   ?
;		rcall	IntTmr1
; #endif
;NextInt1
;
; #ifdef	IntPortB_Present
;	btfss	INTCON,RBIF,ACCESS	;  -    1 10   	
;		bra	NextInt2
;	btfsc	INTCON,RBIE,ACCESS	;;   ?
;		rcall	IntPortB
; #endif
;NextInt2
;
; #ifdef	Timer5_Present
;	btfss	PIR3,TMR5IF,ACCESS	;  TMR5  ?
;		bra		NextInt3			;
;	btfsc	PIE3,TMR5IE,ACCESS		;   ?
;		rcall	IntTmr5	;bra		Int_Timer2			;
; #endif
;NextInt3
;
;; #ifdef	ADC_Present
;;	btfss	PIR1,ADIF,ACCESS	; ADC
;;		bra	NextInt4
;;	btfsc	PIE1,ADIE,ACCESS			;   ?
;;		rcall	IntAdc
;; #endif
;;NextInt4
;;
;; #ifdef	PCPWM_Present
;;	btfss	PIR3,PTIF,ACCESS	; PCPWM
;;		bra	NextInt5
;;	btfsc	PIE3,PTIE,ACCESS			;   ?
;;		rcall	IntPWM
;; #endif
;;NextInt5
;;
;; #ifdef	Timer0_Present
;;	btfss	INTCON,TMR0IF,ACCESS ; 0 -    1-Wire  
;;		bra	NextInt0
;;	btfsc	INTCON,TMR0IE,ACCESS		;   ?
;;		rcall	IntTmr0
;; #endif
;;NextInt0
;;
;
;IntPWM	;    
;	bcf	PIR3,PTIF,ACCESS	; PWM Flag Clear
; #ifdef	PCPWM_Present
;;FAST	#include Proj_Dir\PCPWM_3F\Int_PCPWM_3F_4431.inc	
;;    .
; #endif
;		return
;
;IntAdc	;    
;	bcf	PIR1,ADIF,ACCESS	; ADC Flag Clear
; #ifdef	ADC_Present
;	#ifdef	RTK_ADC_Source
;;FAST  		#include Proj_Dir\RTK\Int_RTK_Tmr.inc	;   -   
;	#endif
;;FAST	#include Proj_Dir\ADC\Int_ADC.inc	;     .
; #endif
;		return
;IntTmr0
;	bcf		INTCON,TMR0IF,ACCESS		;;   0
;;	bcf		T0CON,TMR0ON,ACCESS		;  
; #ifdef	Timer0_Present
;; FAST 		#include Proj_Dir\1W\Int_1W.inc	;   .
; #endif
;		return
;IntTmr1	; -1 -    1 .  
;	bcf	PIR1,TMR1IF,ACCESS	; Timer1 Flag Clear
;	#ifndef	RTK_ADC_Source
;  		#include Proj_Dir\RTK\Int_RTK_Tmr.inc	;     -1
;	#endif
;	return
;IntTmr5:
;	bcf		PIR3,TMR5IF,ACCESS	;   
; #ifdef	Timer5_Present
; 		#include Proj_Dir\Int_Tmr5.inc	;   .
; #endif
;	return
;IntPortB	;  -    1 10   
;	movf	PORTB,W,0		;    
;	bcf		INTCON,RBIF,0	;  
; #ifdef	IntPortB_Present
;	andlw	b'11100000'		;   
;	movwf	PortB_Buf,0		;      	
;	bsf		TaskFlag1,1,ACCESS		;  PortB    PortB 
;	#include Proj_Dir\Int_Encoder.inc>	; Encod   .
; #endif
;	return

;HighInt	code	 0x100	;            
;addwf	PCL,F,0	; -- PCL.  U  H     
;   1  2       
;   -  /  .


;     -   , 11.7  23.4  
;IntPWM	;    
;	btfss	PIR3,PTIF,ACCESS	; PWM Flag Clear
;		bra		HiNextInt1
;	bcf	PIR3,PTIF,ACCESS	; PWM Flag Clear
;		retfie ;FAST	; 



;;End of program
		END
